#include <IRremote.h>
#include <IRremoteInt.h>

// initialize components and variables
int RECV_PIN = 11;
IRrecv irrecv(RECV_PIN);
decode_results results;
const long StoredCode = 0x20DFA25D;
const int relayPin =  5;	// Relay pin 
int outputState = 0;
long lastgpioCheck = 0;
long gpiocheckDelay = 2000;

void setup() 
{ 
  Serial.begin(9600);
  irrecv.enableIRIn();
  pinMode(relayPin, OUTPUT);
  digitalWrite(relayPin, LOW);
}

void loop() 
{

  // start pi power on check
  if ((irrecv.decode(&results)) && (outputState == 0)) { 
    if(StoredCode == (results.value)) {
      Serial.println("Infrared Signal recieved. Switching relay on.");
      digitalWrite(relayPin, HIGH);
      outputState = 1; 
    }
    irrecv.resume(); 
  } 
  // end pi power on check
  
  // start pi power off check
  int gpioState = analogRead(A0);
  float voltage = gpioState * (5.0 / 1023.0);
  if ((voltage < 3.10) && (outputState == 1)) 
  {
    if  ( (millis() - lastgpioCheck) > gpiocheckDelay )	// Only run after gpio LOW for 1000ms
    {
      Serial.println("Raspberry Pi powered down. Switching relay off.");
      digitalWrite(relayPin, LOW);
      outputState = 0;
      lastgpioCheck = millis();	// Reset count
    }
  }
  else
  {
    lastgpioCheck = millis();
  }
  // end pi power off check

}



